#include "main.h"
#include "tconfig.h"
#include "menu.h"
#include "menuproc.h"
#include "m_credit.h"
#include "timeloop.h"
#include "sfx.h"
#include "sfxplay.h"



void run_credits_menu(MENU_SYSTEM *ms, int exiting)
{
	MENU_ENTRY me[] = {
		/* draw            , x         , y                           , dp1                                 , key     , k1    , kp1 */
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) - (FONT_H/2)*13, "TeleHack"                          , &mk_exit, MK_END, NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) - (FONT_H/2)*11, "SpeedHack 2002 #1"                 , NULL    , 0     , NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) - (FONT_H/2)* 9, "Ben Davis"                         , NULL    , 0     , NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) - (FONT_H/2)* 5, "Allegro - Shawn Hargreaves        ", NULL    , 0     , NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) - (FONT_H/2)* 3, "   DUMB - yours truly (muahaha)   ", NULL    , 0     , NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) - (FONT_H/2)* 1, "          and Robert J Ohannessian", NULL    , 0     , NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) + (FONT_H/2)* 3, "Good luck to all the participants" , NULL    , 0     , NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) + (FONT_H/2)* 5, "- but we all know that Shawn"      , NULL    , 0     , NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) + (FONT_H/2)* 7, "  and co are going to win :)"      , NULL    , 0     , NULL},
		{&md_textout_centre, GFX_W >> 1, (GFX_H >> 1) + (FONT_H/2)*11, NULL                                , NULL    , 0     , NULL},
		{NULL              , 0         , 0                           , NULL                                , NULL    , 0     , NULL}
	};

	MENU_DATA *md;

	if (exiting)
		me[9].dp1 = "Press Enter or Space to exit";
	else
		me[9].dp1 = "Press Enter or Space to continue";

	md = wrap_menu_data(ms, me, 0);
	timeloop(BPS_TO_TIMER(MENU_FPS), 10, &t_draw_menu, &t_update_menu, md);
	unwrap_menu_data(md);

	sfx_play(sfx_menu_enter, 1, 0, 1.0);
}

